(function(mui, owner) {
	//url前缀
	var appUrl = baseUtils.URL;
	//纳税人名称（姓名）
	var nsrmc = UserInfoUtils.getUserInfo().nsrmc;
	//纳税人识别号（身份证号）
	var nsrsbh = UserInfoUtils.getUserInfo().nsrsbh;
	//登记序号
	var djxh = UserInfoUtils.getUserInfo().djxh
	
	owner.pageload = function(webview) {
		owner.myInit();
		owner.addEvent();
	}
	// 初始化
	owner.myInit = function() {
		document.getElementById('nsrmc').innerText = UserInfoUtils.getUserInfo().nsrmc;
		document.getElementById('nsrsbh').innerText = UserInfoUtils.getUserInfo().nsrsbh;
		
		var now = new Date(); //当前日期
		var startDate = new Date('2021','06','01'); //月份加1，7月1号
		if(now.getTime()<startDate.getTime()){//如果不是2021年7月1号后，则默认20210701
			document.querySelector("#myDtPickerIdQ").value = '2021-07-01'; 
			document.querySelector("#myDtPickerIdZ").value = '2021-07-01'; 
		}else{
			document.querySelector("#myDtPickerIdQ").value = baseUtils.getDateStr(new Date(),0); //按次当天
			document.querySelector("#myDtPickerIdZ").value = baseUtils.getDateStr(new Date(),0); //按次当天
		}
		owner.sbcsh();
	}
	
	//刷新
	owner.refresh = function() {
		owner.myInit();
	}
	
	//添加事件
	owner.addEvent = function() {
		//绑定监听事件
		document.getElementById("nextBtn").addEventListener("tap", function() {
			owner.sbsubmit();
		});
		document.getElementById("myDtPickerIdQ").addEventListener("tap", function() {
			owner.getDtPicker(this,'Q');
		});
		document.getElementById("myDtPickerIdZ").addEventListener("tap", function() {
			owner.getDtPicker(this,'Z');
		});
	}
	// 封装日历控件,业务特殊自己重写下方法
	owner.getDtPicker = function(obj,bj) {
		var _self = obj;
		if (_self.picker) {
			_self.picker.show(function(rs) {
				console.log("rs--" + JSON.stringify(rs));
				_self.value = rs.text;
				_self.picker.dispose();
				_self.picker = null;
				if(bj == 'Q' && document.querySelector("#myDtPickerIdQ").value.substr(8,10) != '01'){
					document.querySelector("#myDtPickerIdZ").value= rs.text;
				}
				owner.checkskksq();
			});
		} else {
			var optionsJson = obj.getAttribute('data-options') || '{}';
			var options = JSON.parse(optionsJson);
			var id = obj.getAttribute('id');
			_self.picker = new mui.DtPicker(options);
			_self.picker.show(function(rs) {
				_self.value = rs.text;
				_self.picker.dispose();
				_self.picker = null;
				if(bj == 'Q' && document.querySelector("#myDtPickerIdQ").value.substr(8,10) != '01'){
					document.querySelector("#myDtPickerIdZ").value= rs.text;
				}
				owner.checkskksq();
			});
		}
	
		var defaultData = obj.getAttribute('data-default');
		if ("" != defaultData) {
			_self.picker.setSelectedValue(defaultData);
		}
	}
	//校验税款所属期
	owner.checkskksq = function() {
		var skssqq = document.querySelector("#myDtPickerIdQ").value.trim();
		var skssqz = document.querySelector("#myDtPickerIdZ").value.trim();
		var begin=new Date(skssqq.replace(/-/g,"/"));
		var end=new Date(skssqz.replace(/-/g,"/"));
		var rs = checktDate(begin,end,12345);
		if(rs != ""){
			dialog.alert("费款所属期错误，请选择标准的次、月、季、半年、年度费款所属期！");
			document.getElementById('submitBtn').classList.add('mui-hidden');
		}else{
			owner.sbcsh();
		}
	}
	//初始化
	owner.sbcsh = function() {
		var sbrqq = document.querySelector("#myDtPickerIdQ").value.trim();
		var sbrqz = document.querySelector("#myDtPickerIdZ").value.trim();
		var tran_id = tranIdInfo.ljclinit;
		var taxML = {
					"skssqq": sbrqq,
					"skssqz": sbrqz
				};
		var reqInfo = ReqInfo.getReqInfo(tran_id,taxML);
		mui.showLoading("获取数据中...");
		console.log(JSON.stringify(reqInfo));
		$http.post(appUrl,reqInfo,(res)=>{
			console.log(JSON.stringify(res));
			mui.hideLoading();
			if(res != null && res != ''){
				var code_head = res.head.rtn_code;
				if(code_head == '0'){
					document.getElementById('submitBtn').classList.remove('mui-hidden');
					var sbxxlist = JSON.parse(res.body.taxML.mx1);
					for(var i = 0;i<sbxxlist.length;i++){
						document.getElementById('zsxmDm').value = sbxxlist[i].zsxmDm;
						document.getElementById('zspmDm').value = sbxxlist[i].zspmDm;
						document.getElementById('zspmMc').value = sbxxlist[i].zspmMc;
						document.getElementById('jfyj').value = "";
						document.getElementById('zsbl').value = parseFloat(sbxxlist[i].zsbl);
						document.getElementById('sfl').value = parseFloat(sbxxlist[i].sfl).toFixed(2);
						document.getElementById('bqynsfe').value = sbxxlist[i].bqynsfe;
						document.getElementById('bqybtsfe').value = parseFloat(sbxxlist[i].bqybtsfe).toFixed(2);
					}
				}else{
					dialog.alert(res.head.rtn_msg.Message);
					document.getElementById('zsxmDm').value = "";
					document.getElementById('zspmDm').value = "";
					document.getElementById('zspmMc').value = "";
					document.getElementById('jfyj').value = "";
					document.getElementById('zsbl').value = "";
					document.getElementById('sfl').value = "";
					document.getElementById('bqynsfe').value = "";
					document.getElementById('bqybtsfe').value = "";
					document.getElementById('submitBtn').classList.add('mui-hidden');
				}
				
			}else{
				dialog.alert("数据异常！");
			}
		});
	}
	owner.sbsubmit = function() {
		document.getElementById('bqynsfe').value;
		document.getElementById('bqybtsfe').value;
		var zsxmDm = document.getElementById('zsxmDm').value;
		var zspmDm = document.getElementById('zspmDm').value;
		var zspmMc = document.getElementById('zspmMc').value;
		var skssqq = document.querySelector("#myDtPickerIdQ").value;
		var skssqz = document.querySelector("#myDtPickerIdZ").value;
		var jfyj = document.getElementById('jfyj').value;
		var sfl = document.getElementById('sfl').value;
		var zsbl = document.getElementById('zsbl').value;
		var bqynsfe = document.getElementById('bqynsfe').value;
		var bqybtsfe = document.getElementById('bqybtsfe').value;
		var sbxx = [];
		var sbxxobj = {
			"zsxmDm" : zsxmDm,
			"zspmDm" : zspmDm,
			"zspmMc" : zspmMc,
			"skssqq" : skssqq,
			"skssqz" : skssqz,
			"jfyj" : jfyj,
			"sfl" : sfl,
			"zsbl" : zsbl,
			"bqynsfe" : bqynsfe,
			"bqybtsfe" : bqybtsfe
		};
		sbxx.push(sbxxobj);
		if (skssqq == "undefined" || skssqq == null || skssqq == "" 
			|| skssqz == "undefined" || skssqz == null || skssqz == "") {
			dialog.alert("请选择费款所属期");
			return;
		}
		if (sfl == "undefined" || sfl == null || sfl == ""
			|| zspmDm == "undefined" || zspmDm == null || zspmDm == "") {
			dialog.alert("征收标准为空，请选择费款所属期，提取相应数据");
			return;
		}
		if (jfyj == "undefined" || jfyj == null || jfyj == "") {
			dialog.alert("请输入本期应纳费额");
			return;
		}
		if(jfyj <=0 ){
			dialog.alert("本期应纳费额需大于0");
			return;
		}
		var tran_id = tranIdInfo.ljclsave;
		var taxML = {
						"sbxx": sbxx
					};
		var reqInfo = ReqInfo.getReqInfo(tran_id,taxML);
		console.log("请求报文："+JSON.stringify(reqInfo));
		mui.showLoading("操作中...");
		$http.post(appUrl,reqInfo,(res)=>{
			mui.hideLoading();
			console.log("返回报文："+JSON.stringify(res));
			if(res != null && res != ''){
				var code_head = res.head.rtn_code;
				if(code_head == '0'){
					console.log(JSON.stringify(res.body.taxML.tetrunVO));
					mui.alert(JSON.stringify(res.body.taxML.tetrunVO));
					document.getElementById('submitBtn').classList.add('mui-hidden');
					mui.openWindow({
						url: 'ljclfsbxx.html',
						id: "ljclfsbxx.html",
						extras: {
							sbxx:res.body.taxML.returnVO,
							skssqq: skssqq,
							skssqz: skssqz
						}
					});
				}else{
					dialog.alert(res.head.rtn_msg.Message);
				}
				
			}else{
				mui.toast("数据异常！");
			}
		});
	}
}(mui, window.ljclfsb = {}));
