
var mySwiper = new Swiper('.swiper-container', {
	observer:true,
	observeParents:true,
	direction: 'vertical'
})
var startScroll, touchStart, touchCurrent;
mySwiper.slides.on('touchstart', function (e) {
  startScroll = this.scrollTop;
  touchStart = e.targetTouches[0].pageY;
}, true);
mySwiper.slides.on('touchmove', function (e) {
  touchCurrent = e.targetTouches[0].pageY;
  var touchesDiff = touchCurrent - touchStart;
  var slide = this;
  var onlyScrolling =
	(slide.scrollHeight > slide.offsetHeight) &&
	(
	  (touchesDiff < 0 && startScroll === 0) ||
	  (touchesDiff > 0 && startScroll === (slide.scrollHeight - slide.offsetHeight)) ||
	  (startScroll > 0 && startScroll < (slide.scrollHeight - slide.offsetHeight))
	);
  if (onlyScrolling) {
	e.stopPropagation();
  }
}, true);
mySwiper.on('slideChangeTransitionEnd', function () {
  if(this.activeIndex==0){
	  $('.swiper-arrow').hide();
  }else{
	  (this.activeIndex == (this.slides.length - 1)) ? $('.swiper-arrow').hide(): $('.swiper-arrow').show();
  }
  if(!ifmxwc){
	  showLoading();
  }
})

var djJson=[
	{
		name:"A",
		imgurl:"./images/A.png",
		bubblelabel:"非常棒！<br/>最高的等级哦！"
	},
	{
		name:"B",
		imgurl:"./images/B.png",
		bubblelabel:"还不错！<br/>还有进步空间哦！"
	},
	{
		name:"C",
		imgurl:"./images/C.png",
		bubblelabel:"不怎么好哦！<br/>失分点有点多！"
	},
	{
		name:"D",
		imgurl:"./images/D.png",
		bubblelabel:"您今年评价结果<br/>不怎么样呀！要多努力了！"
	},
	{
		name:"M",
		imgurl:"./images/M.png",
		bubblelabel:"您是新设立的企业;<br/>或您评价年度内无生产经营业务<br/>收入且评价指标得分70分以上"
	}
]

var djxh = UserInfoUtils.getUserInfo().djxh;

var nsrmc = UserInfoUtils.getUserInfo().nsrmc;

var nsrsbh = UserInfoUtils.getUserInfo().nsrsbh;

var lastYear = new Date().getFullYear() - 1;

var zbxx;
var mxlist;
var ifmxwc=false;

function getData(){
	var taxML = {"actionName": "Ndswzd","methodName": "ndswzd","excuteType":"query","queryType":"zb","ssnd":lastYear,"djxh":djxh,"nsrsbh":nsrsbh};
	var reqInfo = ReqInfo.getReqInfo(itbysTran_id,taxML);
	console.log("+++++++++++ taxML +++++++++++++ "+JSON.stringify(reqInfo));
	showLoading();
	$http.post(itbysAppJmUrl,reqInfo,(res)=>{
		console.log("res>>>"+JSON.stringify(res))
		hideLoading(); 
		if (res != null && res != '') {	
			var data = res.data;
			if(data && data.zbxx){
				zbxx = data.zbxx;
				mxlist = data.mxlist;
				var ifhavezd=true;
				var djlabel="";
				djlabel = zbxx.NSXYDJ;
				if(djlabel == 'B' || djlabel == 'C' || djlabel == 'D' || djlabel == 'M'){
					getMxlist();
					ifmxwc = false;
				}else{
					ifmxwc = true;
				}
				$("#curYear").html("欢迎查收您的"+zbxx.SSND+"年度");
				if(ifhavezd){
					$(".havezd").css({"display":"block"});
					$(".nozd").css({"display":"none"});
					if(djlabel=="A"){
						$(".Djfirst").css({"display":"block"});
						$(".Djother").css({"display":"none"});
					}else if(djlabel=="" || djlabel=="无" ){ 
						$(".Djfirst").css({"display":"none"});
						$(".Djother").css({"display":"none"});
					}else {
						$(".Djfirst").css({"display":"none"});
						$(".Djother").css({"display":"block"});
						
						djJson.forEach(function(ele){
							if(ele.name==djlabel){
								$(".page-7").find(".djimg").attr("src",ele.imgurl);
								$(".page-7").find(".bubble").html(ele.bubblelabel);
								if(djlabel=="M"){
									$(".page-7").find(".bubble").css({"padding":"20px 15px","right":"20px"})
									$(".page-7 .pliceimg").addClass("lnogjjplicecss").removeClass("longplicebox")
								}
							}
						})
					}
					
					getPieData();
										
				}else{
					$(".havezd").css({"display":"none"});
					$(".nozd").css({"display":"block"});
				}
			}else{
				$(".havezd").css({"display":"none"});
				$(".nozd").css({"display":"block"});
				dialog.alert("未查询到年度税务账单信息！");
			}
		} else {
			dialog.autoCloseDialogIfNoData("数据异常！");
		}		
	});

	$('.p1-btn,.swiper-arrow').on('click', function () {
		mySwiper.slideNext();
		if(mySwiper.activeIndex==0){
			$('.swiper-arrow').hide();
		}else{
			(mySwiper.activeIndex == (mySwiper.slides.length - 1)) ? $('.swiper-arrow').hide(): $('.swiper-arrow').show();
		}
		$(".swiper-wrapper")[0].style.transform="translate3d(0px, -"+$(".swiper-wrapper").innerHeight()+"px, 0px)";
		$(".swiper-wrapper").css('transition-duration','300ms');
	})
	
	$('.p8-btn').on('click', function () {
	  mySwiper.slideTo(0); 
	})
	
	$('.dialog-close,.ewm-close').on('click', function () {
	  $('.mod-dialog').hide();
	  $('.dialog-content').hide();
	})

}
					
										
function getMxlist(){
	var lastYear = new Date().getFullYear() - 1;
	var taxML = {"actionName": "Ndswzd","methodName": "ndswzd","excuteType":"query","queryType":"mxlist","ssnd":lastYear,"djxh":djxh,"nsrsbh":nsrsbh};
	var reqInfo = ReqInfo.getReqInfo(itbysTran_id,taxML);

	$http.post(itbysAppJmUrl,reqInfo,(res)=>{
		ifmxwc=true;
		mui.hideLoading();
		if (res != null && res != '') {			
			var data = res.data;
			if(data && data.zbxx){	
				zbxx = data.zbxx;
				mxlist = data.mxlist;
				console.log("data>>>"+JSON.stringify(mxlist))
				if(mxlist == undefined || mxlist.length == 0){
					$(".sfdshowhide").css({"display":"none"});
				}else{
					var sfdlist=[];
					mxlist.forEach(function(ele,index){
						sfdlist.push(ele.ZBMC==undefined?ele.zbmc:ele.ZBMC);	
					})		
					if(sfdlist.length>0){
						$(".sfdmorebox").html("");
						$(".moresfd").html("");
						sfdlist.forEach(function(ele,index){
							if(index<3){
								var sfditem='<div class="djitem"><em>'+(index+1)+'</em><span>'+ele+'</span></div>'
								$(".sfdmorebox").append(sfditem);
							}
							$(".moresfd").append('<li>'+ele+'</li>');
						})
						if(sfdlist.length>=4){
							$(".sfdmorebox span").addClass("splitext");
							$(".sfdmorebox").append('<div class="djitemmore">点击可查看更多哦！>></div>');
						}
						$('.djitemmore,.sfdmorebox .djitem').on('click', function () {
						  $('.mod-dialog').show();
						  $('.dia-jbgz').show();
						})
					}
				}																			
			}
		} 	
	});
}

var p2Chart;
var p3Chart;

function getPieData(){
	p2Chart = echarts.init(document.getElementById('p2-pie'));
	p3Chart = echarts.init(document.getElementById('p3-pie'));
	var zzsjn = zbxx.ZZSJN;
	var qysdsjn = zbxx.QYSDSJN;
	var grsdsjn = zbxx.GRSDSJN;
	var fjsfjn = zbxx.FJSFJN;
	var sbfjn = zbxx.SBFJN;
	var qtsfjn = zbxx.QTSFJN;
	var hjjn = zbxx.HJJN;
	var sumhjjn = zbxx.HJJN;
	if(hjjn==0) hjjn = 1;
	
	var datajson={
		xdata:["增值税","企业所得税","扣缴个税","附加税费","社保费","其他税费"],
		ydata:[{
			name:"税费",
			value:[zzsjn,qysdsjn,grsdsjn,fjsfjn,sbfjn,qtsfjn],
			zb:[(zzsjn*100/hjjn).toFixed(2),(qysdsjn*100/hjjn).toFixed(2),(grsdsjn*100/hjjn).toFixed(2),(fjsfjn*100/hjjn).toFixed(2),(sbfjn*100/hjjn).toFixed(2),(qtsfjn*100/hjjn).toFixed(2)]
		}]
	}
	
	var zzsjm = zbxx.ZZSJM;
	var qysdsjm = zbxx.QYSDSJM;
	var grsdsjm = zbxx.GRSDSJM;
	var fjsfjm = zbxx.FJSFJM;
	var sbfjm = zbxx.SBFJM;
	var qtsfjm = zbxx.QTSFJM;
	var hjjm = zbxx.HJJM;
	var sumhjjm = zbxx.HJJM;
	if(hjjm==0) hjjm = 1;
	
	var datajson1={
		xdata:["增值税","企业所得税","扣缴个税","附加税费","社保费","其他税费"],
		ydata:[{
			name:"减免",
			value:[zzsjm,qysdsjm,grsdsjm,fjsfjm,sbfjm,qtsfjm],
			zb:[(zzsjm*100/hjjm).toFixed(2),(qysdsjm*100/hjjm).toFixed(2),(grsdsjm*100/hjjm).toFixed(2),(fjsfjm*100/hjjm).toFixed(2),(sbfjm*100/hjjm).toFixed(2),(qtsfjm*100/hjjm).toFixed(2)]
		}]
	}
	
	var wsbscs = zbxx.WSBSCS;
	var ckbscs = zbxx.CKBSCS;
	var datajson2={
		xdata:["网上办税","窗口办税"],
		ydata:[wsbscs,ckbscs]
	}
	
	$(".pieul1").html("");
	$(".pieul2").html("");
	datajson.xdata.forEach(function(ele,index){
		var czvalue=parseFloat(datajson.ydata[0].value[index]/10000).toFixed(2);
		var listr='<li class="i'+(index+1)+'"><span class="piename">'+ele+'</span><div class="fr"><span class="pievlue">'+czvalue+'</span>万元</div></li>';
		$(".pieul1").append(listr);
	})
	datajson1.xdata.forEach(function(ele,index){
		var czvalue1=parseFloat(datajson1.ydata[0].value[index]/10000).toFixed(2);
		var listr='<li class="i'+(index+1)+'"><span class="piename">'+ele+'</span><div class="fr"><span class="pievlue">'+czvalue1+'</span>万元</div></li>';
		$(".pieul2").append(listr);
	})
	
	$(".page-2 .p1-title").html(parseFloat(sumhjjn/10000).toFixed(2));
	$(".page-3 .p1-title").html(parseFloat(sumhjjm/10000).toFixed(2));

	p2Chart.setOption(getOption(datajson));
	p3Chart.setOption(getOption(datajson1));
	
	datajson2.ydata.forEach(function(ele,index){
		$(".page-4 .inlineflex").eq(index).find(".p1-title").html(ele)
	})
}
function setPieData(datajson){
	var pieData=[];
	for(var i=0;i<datajson.xdata.length;i++){
		pieData.push({
			value:datajson.ydata[0].value[i], 
			name:datajson.xdata[i],
			zb:datajson.ydata[0].zb[i]
		})
	}
	return pieData;
}
function getOption(datajson){
	return {
		color:["#F85040","#FA991F","#F9D503","#2A91E5","#31BBB6","#D8D8D8"],
		title:{
			text:"各类"+datajson.ydata[0].name+"占比分布图",
			bottom:"0",
			x:"4%",
			textStyle:{
				fontSize:12,
				color:"#111659"
			}
		},
		legend:{
			data:datajson.xdata,
			right:"0",
			top:'middle',
			orient:'vertical',
			itemGap: 6 ,
			itemWidth:4,
			itemHeight:4,
			formatter: function (name) {
				var ci=0;
				datajson.xdata.forEach(function(ele,index){
					if(ele==name){
						ci=index;
					}
				})
				return name+'{a|'+datajson.ydata[0].zb[ci]+'%}';
			},
			textStyle:{
				 rich: {
					a: {
						color: '#1E39B2',
						fontSize:14,
						padding:[0,5]
					},
				}
			}
		},
		series: [
			{
				type:'pie',
				radius: ['0%', '74%'],
				center:['27%','45%'],
				avoidLabelOverlap: false,
				label: {
					normal: {
						show: false,
						position: 'center'
					}
					
				},
				labelLine: {
					normal: {
						show: false
					}
				},
				data:setPieData(datajson)
			}
		]
	}
};
