// 添加报表时所属期判断 （标准月1、季2、半年3、年4、次5）
function checktDate(date1,date2,bz){
	var checkInfo = "";
	if(bz == 1){ // 判断是否是标准月
		checkInfo = checkMonth(date1,date2);
	}
	else if(bz == 2){ // 判断是否是标准季
		checkInfo = checkSeason(date1,date2);
	}
	else if(bz == 3){ // 判断是否是标准半年
		checkInfo = checkHalfYear(date1,date2);
	}
	else if(bz == 4){ // 判断是否是标准年
		checkInfo = checkYear(date1,date2);
	}
	else if(bz == 5){ // 判断是否是标准次
		checkInfo = checkTimes(date1,date2);
	}
	else if(bz == 12){ // 判断是否是标准月、季
		checkInfo = checkMonth(date1,date2);
		if(checkInfo!=""){
			checkInfo = checkSeason(date1,date2);
			if(checkInfo!=""){
				checkInfo = "税款所属期错误，请选择标准的月、季度税款所属期！";
			}
		}
	}
	else if(bz == 15){ // 判断是否是标准月、次
		checkInfo = checkTimes(date1,date2);
		if(checkInfo!=""){
			checkInfo = checkMonth(date1,date2);
			if(checkInfo!=""){
				checkInfo = "税款所属期错误，请选择标准的按次、月税款所属期！";
			}
		}
	}
	else if(bz == 123){ // 判断是否是标准月、季、半年
		checkInfo = checkMonth(date1,date2);
		if(checkInfo!=""){
			checkInfo = checkSeason(date1,date2);
			if(checkInfo!=""){
				checkInfo = "税款所属期错误，请选择标准的月、季、半年度税款所属期！";
			}
		}
	}
	else if(bz == 124){ // 判断是否是标准月、季、年
		checkInfo = checkMonth(date1,date2);
		if(checkInfo!=""){
			checkInfo = checkSeason(date1,date2);
			if(checkInfo!=""){
				checkInfo = checkYear(date1,date2);
				if(checkInfo!=""){
					checkInfo = "税款所属期错误，请选择标准的月、季、年度税款所属期！";
				}
			}
		}
	}
	else if(bz == 1234){ // 判断是否是标准月、季、半年、年
		checkInfo = checkMonth(date1,date2);
		if(checkInfo!=""){
			checkInfo = checkSeason(date1,date2);
			if(checkInfo!=""){
				checkInfo = checkHalfYear(date1,date2);
				if(checkInfo!=""){
					checkInfo = checkYear(date1,date2);
					if(checkInfo!=""){
						checkInfo = "税款所属期错误，请选择标准的月、季、半年、年度税款所属期！";
					}
				}
			}
		}
	}
	else{
		if(!(checkMonth(date1,date2)=="" // 判断是否是标准月
				||checkSeason(date1,date2)==""// 判断是否是标准季
				||checkHalfYear(date1,date2)=="" // 判断是否是标准半年
				||checkYear(date1,date2)=="" // 判断是否是标准年
				||checkTimes(date1,date2)=="" // 判断是否是标准次
				)){
			checkInfo = "税款所属期错误，请选择标准的次、月、季、半年、年度税款所属期！";
		}
	}
	return checkInfo;
}
// 判断是否是标准月
function checkMonth(date1,date2){
	var checkInfo = "";
	var date1year = date1.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date1month = date1.getMonth()+1;
	var date2year = date2.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date2month = date2.getMonth()+1;
	var firstDay = new Date(date1year, date1month-1, 1); //第一天 ;
	var lastDay =  new Date(date2year, date2month, 0); // 最后一天 
	if(date1year!=date2year||date1month!=date2month||date1.getTime()!=firstDay.getTime()||date2.getTime()!=lastDay.getTime()){
		checkInfo = "税款所属期错误，请选择正确的月初月末！";
		return checkInfo;
	}
	return checkInfo;
}
// 判断是否是标准季
function checkSeason(date1,date2){
	var checkInfo = "";
	var date1year = date1.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date1month = date1.getMonth()+1;
	var date2year = date2.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date2month = date2.getMonth()+1;
	var firstDay = new Date(date1year, date1month-1, 1); //第一天 ;
	var lastDay =  new Date(date2year, date2month, 0); // 最后一天 
	if(date1.getTime()!=firstDay.getTime()||date2.getTime()!=lastDay.getTime()
			||date1year!=date2year
			||date2month-date1month!=2
			||!(date1month==1||date1month==4||date1month==7||date1month==10)
			){
		checkInfo = "税款所属期错误，请选择正确的季初季末！";
	}
	return checkInfo;
}
// 判断是否是标准半年
function checkHalfYear(date1,date2){
	var checkInfo = "";
	var date1year = date1.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date1month = date1.getMonth()+1;
	var date2year = date2.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date2month = date2.getMonth()+1;
	var firstDay = new Date(date1year, date1month-1, 1); //第一天 ;
	var lastDay =  new Date(date2year, date2month, 0); // 最后一天 
	if(date1.getTime()!=firstDay.getTime()||date2.getTime()!=lastDay.getTime()
			||date1year!=date2year
			||date2month-date1month!=5
			||!(date1month==1||date1month==7)
			){
		checkInfo = "税款所属期错误，请选择正确的半年初半年末！";
	}
	return checkInfo;
}
// 判断是否是标准年
function checkYear(date1,date2){
	var checkInfo = "";
	var date1year = date1.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date1month = date1.getMonth()+1;
	var date2year = date2.getFullYear(); // 得到年份,getFullYear()比getYear()更普适;
	var date2month = date2.getMonth()+1;
	var firstDay = new Date(date1year, date1month-1, 1); //第一天 ;
	var lastDay =  new Date(date2year, date2month, 0); // 最后一天 
	if(date1.getTime()!=firstDay.getTime()||date2.getTime()!=lastDay.getTime()
			||date1year!=date2year
			||date2month-date1month!=11
			||!(date1month==1)
			){
		checkInfo = "税款所属期错误，请选择正确的年初年末！";
	}
	return checkInfo;
}
// 判断是否是标准次
function checkTimes(date1,date2){
	var checkInfo = "";
	if(date1.getTime()!=date2.getTime()){
		checkInfo = "税款所属期错误，请选择同一天！";
	}
	return checkInfo;
}
