( function( global, factory ,plug) {

	//"use strict";

	if ( typeof module === "object" && typeof module.exports === "object" ) {
		module.exports = global.document ?
			factory( global, true,plug ) :
			function( w ) {
				if ( !w.document ) {
					throw new Error( "jQuery requires a window with a document" );
				}
				return factory( w,undefined,plug );
			};
	} else {
		factory( global,undefined,plug );
	}

} )( typeof window !== "undefined" ? window : this, function( window, noGlobal,plug) {
	/**
	 * 基于jq的表单校验
	 * <div>
			<label>完税证明编号:</label>
	   </div>
	   <div class="mui-input-row">
			<input id="wszmbh" type="text"  placeholder="请输入完税证明编号" v-model="wszmbh" data-mv-required="true">
	   </div>	
	*/
	const _CONF_ = {
			_prefix_:"mv-",
			_find_: "input,select,list,textarea",
			_filter_: "[type=submit],[type=reset],[type=button],[type=image]",
			_css_error_: {"border-bottom":"1px solid #ff0000"},
			_error_msg_:"必填项不能为空"
	};

	const _RULES_ = {
		// 必填项
		"required" : function(){
					var val = this.val();
					return val!=null && val!=undefined && val!="";
				},
		//邮箱
		"email" : function(){
			return /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/.test(this.val());
		},
		"phone": function(){
			
		},
		//正则表达式
		"regex" : function(){
			console.log("正则表达式>>>"+this.attr("data-mv-regex"))
			let regex = this.attr("data-mv-regex")
			return new RegExp(regex).test(this.val());
		},
		"max": function(){
			let max = this.attr("data-mv-max")
			console.log("最大长度>>>"+max)
			return this.val().length < max;
		}
	}
	//触发的事件
	const _OPS_ = {
		raise:"input"
	}
	var $ = window.jQuery
	$.fn[plug] = function(options){
		//扩展参数
		options = $.extend(_OPS_,options)
		//表单
		let $this = $(this)
		//符合条件的表单元素
		var $fields = $this.find(_CONF_._find_).not(_CONF_._filter_);
		//监听表单元素
		$fields.on(options.raise,function(){
			//当前被校验的目标元素
			var $filed = $(this);
			//清空提示信息
			$filed.parent().next("span").remove();
			//清空提示样式
			$filed.parent().css("border-bottom","1px solid #eeeeee")
			//$filed.css({"border-bottom-width": "","border-color":"","border-style": ""})
			//遍历规则，匹配规则
			$.each(_RULES_,function(rule,validateFn){
				//判断当前元素是否含有匹配规则
				let _r = $filed.data(_CONF_._prefix_+rule)
				if(_r){
					//校验规则
					let result = validateFn.call($filed)
					//-error中的信息
					let _err = $filed.data(rule+"-error")
					if(!result){
						$filed.parent().css(_CONF_._css_error_)
						$filed.parent().after("<span class='mv-span' style='color: red;margin-left: 10px;'>"+(_err||_CONF_._error_msg_)+"</span>")
					}
					return result
				}
			})
		})
	}
	//触发表单监听事件
	$.fn['triggerFormValidate'] = function(options){
		//扩展参数
		options = $.extend(_OPS_,options)
		//表单
		let $this = $(this)
		//符合条件的表单元素
		var $fields = $this.find(_CONF_._find_).not(_CONF_._filter_);
		$fields.trigger(options.raise)
		return $fields.parents().parents().find(".mv-span").size()
	}
	//清除样式
	$.fn['removeErrorCss'] = function(){
		this.parent().next("span").remove();//清空提示信息
		this.parent().css("border-bottom","1px solid #eeeeee")//清空提示样式
	}
} ,"muiValidator");
