( function( global, factory ,plug) {
	//"use strict";
	if ( typeof module === "object" && typeof module.exports === "object" ) {
		module.exports = global.document ?
			factory( global, true,plug ) :
			function( w ) {
				if ( !w.document ) {
					throw new Error( "jQuery requires a window with a document" );
				}
				return factory( w,undefined,plug );
			};
	} else {
		factory( global,undefined,plug );
	}

} )( typeof window !== "undefined" ? window : this, function( window, noGlobal,plug) {
	/**
	 * @param {Object} data  对象数组
	 * @param {Object}dataMap 搜索数据map
	 * @param {Object} layer  层数
	 * @param {Object} callFn 回调方法，获取选中的值
	 */
	var $ = window.jQuery
	$.fn['treePickerList'] = function(data,layer,callFn,dataMap){
		var $this = $(this)
		var html
		var dataMap = dataMap || getDataMap(data,new Map())
		console.log(dataMap)
		if(layer === 3){
			html = `
				<div class="mui-popup-backdrop mui-active" style="display: block;" id="_mui_mask_"></div>
				<div class="all">
					<p class="choice">
						<span class="xz"></span>
						<span class="mui-icon mui-icon-closeempty"></span>
					</p>
					<div id="search">
						<p class="box">
							<span class="mui-icon mui-icon-search"></span>
							<input type="text" placeholder="请输入关键字检索" id="_search_">
						</p>
					</div>	
					<div class="wrap">
						<div class="accordion" id="_accordion_">
							${data.map(item => `
								<p style="padding-bottom:10px"><em class="iconfont icon-xiangshang"></em>${item.text}</p>
								<div class="accordion">
									${item.children.map(item2 =>`
										<p style="padding-bottom:10px"><em class="iconfont icon-add"></em>${item2.text}</p>
										<ul>
											${item2.children.map(item3=>`
												<li class="liText" value="${item3.value}" style="padding-top:10px;padding-bottom:10px;">${item3.text}</li>
											`).join('')}
										</ul>
									`).join('')}
								</div>
							  `).join('')}
						</div>
					</div>
				</div>`
		}
		if(layer === 2){
			html = `
				<div class="mui-popup-backdrop mui-active" style="display: block;" id="_mui_mask_"></div>
				<div class="all">
					<p class="choice">
						<span class="xz"></span>
						<span class="mui-icon mui-icon-closeempty"></span>
					</p>
					<div id="search">
						<p class="box">
							<span class="mui-icon mui-icon-search"></span>
							<input type="text" placeholder="请输入关键字检索" id="_search_">
						</p>
					</div>	
					<div class="wrap">
						<div class="accordion" id="_accordion_">
							${data.map(item => `
								<p style="padding-bottom:10px"><em class="iconfont icon-xiangshang"></em>${item.text}</p>
									<ul>
										${item.children.map(item2 =>`
												<li class="liText" value="${item2.value}" style="padding-top:10px;padding-bottom:10px;">${item2.text}</li>
										`).join('')}
									</ul>
							  `).join('')}
						</div>
					</div>
				</div>`	
		}
		//拼接
		$this.append(html)
		$(".all").css({"display":"block"})
		// 折叠列表
		$(".accordion>p").click(function(){
			if($(this).hasClass("active")){
				$(this).find("em").removeClass("icon-jian").addClass("icon-xiangshang");
				$(this).removeClass("active").next().slideUp("fast");
			}
			else{
				$(this).find("em").removeClass("icon-add").addClass("icon-jian");
				$(this).addClass("active").next().slideDown("fast");
			}
		});
		//监听x号
		$(".mui-icon-closeempty").click(function(){
			hideAll()
		});
		//监听点击
		liTextListener(callFn)
		//监听搜索输入
		$("#_search_").on("input",function(){
			let searchword = $("#_search_").val()
			if(searchword){
				$("#_accordion_").hide()
				if($("#_searchResult_")){
					$("#_searchResult_").remove()
				}
			}else{
				$("#_accordion_").show()
				if($("#_searchResult_")){
					$("#_searchResult_").remove()
					return
				}
			}
			let searchResult = []
			dataMap.forEach((value,key)=>{
				 if(key.indexOf(searchword) != -1){
					 searchResult.push({"text":key,"value":value})
				 }
			})
			let resultHtml = `
					<div id="_searchResult_">
						<ul class="mui-table-view">
							${searchResult.map(item=>`
								<li class="mui-table-view-cell liText" style="padding-top:15px;padding-bottom:15px;" value="${item.value}">${item.text}</li>
							`).join('')}
						</ul>
					</div>`
			$(".wrap").append(resultHtml)
			liTextListener(callFn)
		})
	}
	
	function getDataMap(list,dataMap){
		list.forEach((item,i)=>{
			if(!item.children){
				console.log(item.text,item.value)
				dataMap.set(item.text,item.value)
				return
			}else{
				getDataMap(item.children,dataMap)
			}
		})
		return dataMap
	}
	
	function hideAll(){
		$(".all").hide(300)
		$("#_mui_mask_").remove()
		mui.later(()=>{
			$(".all").remove()
		},300)
	}
	
	function liTextListener(callFn){
		//监听点击
		mui(".liText").each(function(){
			this.addEventListener("tap", function(){
				if(callFn){
					callFn({"text":this.innerText,"value":this.value})
				}
				hideAll()
			})
		})
	}
	
	$.fn['checkboxPickerList'] = function(data,callFn){
		var $this = $(this)
		var html = `
			<div class="mui-popup-backdrop mui-active" style="display: block;" id="_mui_mask_"></div>
			<div id="_checkboxList_">
				<p class="choice">
					<span class="xz"></span>
					<span class="mui-icon mui-icon-closeempty"></span>
				</p>
				<div id="search">
					<p class="box">
						<span class="mui-icon mui-icon-search"></span>
						<input type="text" placeholder="请输入关键字检索" id="_search_">
					</p>
				</div>	
				<div id="_mui_card_">
					<div class="mui-card"  id="_mui_table_view_">
						<ul class="mui-table-view">
							${data.map(item=>`
								<li class="mui-table-view-cell mui-checkbox _checkbox_">
									<div style="width: 90%;margin-bottom:8px;margin-top:8px">
										${item.text}
									</div>
									<input name="checkbox" type="checkbox"  value="${item.value}">
								</li>
							`).join('')}
						</ul>
					</div>
				</div>
			</div>`
		$this.append(html)
		//监听x号
		$(".mui-icon-closeempty").click(function(){
			hideCheckboxList()
		});
		//监听点击
		checkboxListener(callFn)
		//监听输入搜索
		$("#_search_").on("input",function(){
			let searchword = $("#_search_").val()
			if(searchword){
				$("#_mui_table_view_").hide()
				if($("#_searchResult_")){
					$("#_searchResult_").remove()
				}
			}else{
				$("#_mui_table_view_").show()
				if($("#_searchResult_")){
					$("#_searchResult_").remove()
					return
				}
			}
			let searchResult = []
			for(let {text,value} of data){
				if(text.indexOf(searchword) != -1){
					 searchResult.push({"text":text,"value":value})
				}
			}
			
			let resultHtml = `
				<div id="_searchResult_">
					<ul class="mui-table-view">
						${searchResult.map(item=>`
							<li class="mui-table-view-cell mui-checkbox _checkbox_">
								<div style="width: 90%;margin-bottom:8px;margin-top:8px">
									${item.text}
								</div>
								<input name="checkbox" type="checkbox"  value="${item.value}">
							</li>
						`).join('')}
					</ul>
				</div>`
			$("#_mui_card_").append(resultHtml)
			checkboxListener(callFn)
		})
	}
	
	function hideCheckboxList(){
		$("#_checkboxList_").hide(300)
		$("#_mui_mask_").remove()
		mui.later(()=>{
			$("#_checkboxList_").remove()
		},300)
	}
	
	function checkboxListener(callFn){
		//监听点击
		mui("._checkbox_").each(function(){
			this.addEventListener("tap", function(){
				if(callFn){
					callFn({"text":this.children[0].innerText,"value":this.children[1].value})
				}
				hideCheckboxList()
			})
		})
	}
});


